Перейти к основному содержимому

Интеграция с Angular

Подсказка

Предполагается знакомство с основными концепциями и паттернами Angular. Для повторения см. документацию Angular.

DHTMLX Pivot интегрируется с Angular как обычный компонент. Для полного рабочего примера см. демо Angular Pivot на GitHub.

Создание проекта​

К сведению

Перед началом установите Angular CLI и Node.js.

Следующая команда создаёт новый Angular-проект с именем my-angular-pivot-app:

ng new my-angular-pivot-app
Примечание

При запросе Angular CLI отключите Server-Side Rendering (SSR) и Static Site Generation (SSG/Prerendering). Данное руководство предполагает клиентский рендеринг.

Команда установит все необходимые инструменты. Дополнительные команды не требуются.

Установка зависимостей​

Перейдите в директорию нового проекта:

cd my-angular-pivot-app

Установите зависимости и запустите сервер разработки с помощью менеджера пакетов yarn:

yarn
yarn start # или: yarn dev

Приложение должно запуститься на локальном порту (например, http://localhost:3000).

Создание Pivot​

Добавьте пакет Pivot в проект, затем оберните Pivot в Angular-компонент.

Шаг 1. Установка пакета​

Загрузите ознакомительный пакет Pivot и следуйте инструкциям в README. Ознакомительный пакет Pivot действителен в течение 30 дней.

Шаг 2. Создание компонента​

Создайте Angular-компонент, который монтирует Pivot. Добавьте папку pivot в src/app/ и создайте файл src/app/pivot/pivot.component.ts. Затем выполните следующие шаги:

Импорт исходных файлов​

Откройте src/app/pivot/pivot.component.ts и импортируйте пакет Pivot. Путь импорта зависит от редакции пакета:

  • PRO-версия (установлена из локальной папки):
import { Pivot } from 'dhx-pivot-package';
  • Ознакомительная версия:
import { Pivot } from '@dhx/trial-pivot';

В этом руководстве используется ознакомительная версия Pivot.

Настройка контейнера и монтирование Pivot​

Чтобы отобразить Pivot на странице, определите элемент-контейнер в шаблоне компонента, затем инициализируйте Pivot в хуке ngOnInit с помощью конструктора. Уничтожьте Pivot в хуке ngOnDestroy.

Следующий фрагмент кода определяет минимальный Angular-компонент Pivot:

pivot.component.ts
import { Pivot } from '@dhx/trial-pivot';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "pivot", // имя шаблона, используемое в файле "app.component.ts" как <pivot />
styleUrls: ["./pivot.component.css"], // подключение CSS-файла
template: `<div #container className="widget"></div>`,
})

export class PivotComponent implements OnInit, OnDestroy {
// ссылка на контейнер для Pivot
@ViewChild('container', { static: true }) pivot_container!: ElementRef;

private _table!: Pivot;

ngOnInit() {
// инициализация компонента Pivot
this._table = new Pivot(this.pivot_container.nativeElement, {});
}

ngOnDestroy(): void {
this._table.destructor(); // уничтожение Pivot при размонтировании
}
}

Добавление стилей​

Чтобы Pivot отображался корректно, создайте файл src/app/pivot/pivot.component.css со стилями для страницы и контейнера Pivot:

pivot.component.css
/* импорт стилей Pivot */
@import "@dhx/trial-pivot/dist/pivot.css";

/* стили для начальной страницы */
html,
body {
margin: 0;
padding: 0;
height: 100%;
}

/* стили для контейнера Pivot */
.widget {
width: 100%;
height: 100%;
}

Загрузка данных​

Чтобы передать данные в Pivot, подготовьте набор данных. Создайте файл src/app/pivot/data.ts и экспортируйте данные и метаданные полей:

data.ts
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // другие элементы данных
];

const fields: any = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // другие поля
];

return { dataset, fields };
};

Откройте src/app/pivot/pivot.component.ts, импортируйте getData и примените набор данных в ngOnInit():

pivot.component.ts
import { Pivot } from '@dhx/trial-pivot';
import { getData } from "./data"; // импорт данных
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "pivot",
styleUrls: ["./pivot.component.css"],
template: `<div #container className="widget"></div>`,
})

export class PivotComponent implements OnInit, OnDestroy {
@ViewChild('container', { static: true }) pivot_container!: ElementRef;

private _table!: Pivot;

ngOnInit() {
const { dataset, fields } = getData(); // извлечение данных и метаданных полей
this._table = new Pivot(this.pivot_container.nativeElement, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // другие значения
]
},
// другие свойства конфигурации
});
}

ngOnDestroy(): void {
this._table.destructor();
}
}

Компонент готов к использованию. При монтировании Pivot отрисовывается с переданными данными. Полный список свойств конфигурации см. в документации API Pivot.

Обработка событий​

Действия пользователя в Pivot генерируют события, на которые можно подписаться. Полный список событий см. в обзоре событий.

Следующий фрагмент кода расширяет ngOnInit слушателем события open-filter, который выводит в консоль идентификатор поля при открытии фильтра пользователем:

pivot.component.ts
// ...
ngOnInit() {
const { dataset, fields } = getData();
this._table = new Pivot(this.pivot_container.nativeElement, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // другие значения
]
}
});

this._table.api.on("open-filter", (ev) => {
console.log("The field id for which the filter is activated:", ev.id);
});
}

ngOnDestroy(): void {
this._table.destructor();
}

Шаг 3. Добавление Pivot в приложение​

Чтобы встроить PivotComponent в приложение, откройте src/app/app.component.ts и замените код по умолчанию следующим:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<pivot/>` // шаблон, созданный в файле "pivot.component.ts"
})
export class AppComponent {
name = "";
}

Затем создайте файл src/app/app.module.ts и зарегистрируйте PivotComponent:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { PivotComponent } from "./pivot/pivot.component";

@NgModule({
declarations: [AppComponent, PivotComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

Наконец, откройте src/main.ts и замените его содержимое следующим кодом начальной загрузки:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

Запустите приложение, чтобы увидеть отрисовку данных в Pivot на странице.

DHTMLX Pivot, отрендеренный в приложении Angular с демонстрационными данными

Pivot теперь интегрирован с Angular. Настройте конфигурацию в соответствии с требованиями проекта. Итоговый пример см. в angular-pivot-demo на GitHub.

Перейти к основному содержимому

Интеграция с Vue

Подсказка

Предполагается знакомство с базовыми концепциями и паттернами Vue. Для повторения см. документацию Vue 3.

DHTMLX Pivot интегрируется с Vue как обычный компонент. Полный рабочий пример см. в демо Vue Pivot на GitHub.

Создание проекта​

К сведению

Перед началом работы установите Node.js.

Следующая команда запускает официальный инструмент создания проектов Vue:

npm create vue@latest

Команда устанавливает и запускает create-vue. Подробнее см. Быстрый старт Vue.js.

Назовите проект my-vue-pivot-app.

Установка зависимостей​

Перейдите в директорию нового проекта:

cd my-vue-pivot-app

Установите зависимости и запустите сервер разработки с помощью вашего пакетного менеджера:

yarn
yarn start # или: yarn dev
npm install
npm run dev

Приложение должно запуститься на локальном порту (например, http://localhost:3000).

Создание Pivot​

Добавьте пакет Pivot в проект, затем оберните Pivot в компонент Vue.

Шаг 1. Установка пакета​

Скачайте пробный пакет Pivot и следуйте инструкциям в README. Пробный пакет Pivot действителен в течение 30 дней.

Шаг 2. Создание компонента​

Создайте компонент Vue, который монтирует Pivot. Добавьте новый файл src/components/Pivot.vue.

Импорт исходных файлов​

Откройте src/components/Pivot.vue и импортируйте исходные файлы Pivot. Пути импорта зависят от редакции пакета:

  • PRO версия (установленная из локальной папки):
Pivot.vue
<script>
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';
</script>

Если пакет поставляется с минифицированными ресурсами, импортируйте pivot.min.css вместо pivot.css.

  • Пробная версия:
Pivot.vue
<script>
import { Pivot } from '@dhx/trial-pivot';
import '@dhx/trial-pivot/dist/pivot.css';
</script>

В этом руководстве используется пробная версия Pivot.

Настройка контейнера и монтирование Pivot​

Чтобы отобразить Pivot на странице, добавьте контейнер div, затем инициализируйте Pivot в хуке mounted с помощью конструктора. Уничтожьте Pivot в хуке unmounted.

Следующий фрагмент кода определяет минимальный компонент Pivot для Vue:

Pivot.vue
<script>
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default {
mounted() {
// инициализируем компонент Pivot
this.table = new Pivot(this.$refs.container, {});
},

unmounted() {
this.table.destructor(); // уничтожаем Pivot при размонтировании
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Добавление стилей​

Для корректного отображения Pivot добавьте следующие стили в главный CSS-файл проекта:

style.css
/* стили для начальной страницы */
html,
body,
#app { /* используем корневой контейнер #app */
height: 100%;
padding: 0;
margin: 0;
}

/* стили для контейнера Pivot */
.widget {
width: 100%;
height: 100%;
}

Загрузка данных​

Чтобы передать данные в Pivot, подготовьте набор данных. Создайте src/data.js и экспортируйте данные и метаданные полей:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // другие элементы данных
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // другие поля
];

return { dataset, fields };
};

Откройте src/App.vue, импортируйте данные и передайте их через опцию data(). Затем передайте значения новому компоненту <Pivot/> в качестве пропсов:

App.vue
<script>
import Pivot from "./components/Pivot.vue";
import { getData } from "./data";

export default {
components: { Pivot },
data() {
const { fields, dataset } = getData();
return {
fields,
dataset
};
}
};
</script>

<template>
<Pivot :fields="fields" :dataset="dataset" />
</template>

Откройте src/components/Pivot.vue, объявите входящие пропсы и примените их к объекту конфигурации Pivot:

Pivot.vue
<script>
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default {
props: ["fields", "dataset"],

mounted() {
this.table = new Pivot(this.$refs.container, {
fields: this.fields,
data: this.dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // другие значения
]
},
// другие свойства конфигурации
});
},

unmounted() {
this.table.destructor();
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Компонент готов к использованию. При монтировании Pivot отображает данные. Полный список свойств конфигурации см. в документации API Pivot.

Обработка событий​

Действия пользователя в Pivot генерируют события, на которые можно подписаться. Полный список событий см. в Обзоре событий.

Следующий фрагмент кода расширяет mounted обработчиком события open-filter, который выводит в консоль идентификатор поля при открытии фильтра пользователем:

Pivot.vue
<script>
// ...
export default {
// ...
mounted() {
this.table = new Pivot(this.$refs.container, {
fields: this.fields,
data: this.dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // другие значения
]
},
// другие свойства конфигурации
});

this.table.api.on("open-filter", (ev) => {
console.log("Идентификатор поля, для которого активирован фильтр:", ev.id);
});
}
// ...
}
</script>

// ...

Запустите приложение, чтобы увидеть, как Pivot отображает данные на странице.

DHTMLX Pivot, отрендеренный в приложении Vue с демонстрационными данными

Pivot теперь интегрирован с Vue. Настройте конфигурацию в соответствии с требованиями проекта. Финальный пример см. в vue-pivot-demo на GitHub.

Перейти к основному содержимому

Интеграция с React

Подсказка

Предполагается знакомство с базовыми концепциями и паттернами React. Для повторения см. документацию React.

DHTMLX Pivot интегрируется с React как обычный компонент. Для полного рабочего примера см. демо React Pivot на GitHub.

Создание проекта​

К сведению

Перед началом работы установите Node.js. Vite опционален.

Создайте базовый проект React (или проект на основе Vite) с именем my-react-pivot-app.

Следующая команда создаёт проект Create React App:

npx create-react-app my-react-pivot-app

Установка зависимостей​

Перейдите в директорию нового проекта:

cd my-react-pivot-app

Установите зависимости и запустите dev-сервер с помощью вашего пакетного менеджера:

yarn
yarn start # или: yarn dev
npm install
npm run dev

Приложение должно запуститься на локальном порту (например, http://localhost:3000).

Создание Pivot​

Добавьте пакет Pivot в проект, затем оберните Pivot в React-компонент.

Шаг 1. Установка пакета​

Загрузите ознакомительный пакет Pivot и следуйте инструкциям в README. Ознакомительный пакет Pivot действителен в течение 30 дней.

Шаг 2. Создание компонента​

Создайте React-компонент, который монтирует Pivot. Добавьте новый файл src/Pivot.jsx.

Импорт исходных файлов​

Откройте src/Pivot.jsx и импортируйте исходные файлы Pivot. Пути импорта зависят от редакции пакета:

  • PRO-версия (установлена из локальной папки):
Pivot.jsx
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';

Если пакет поставляется с минифицированными ресурсами, импортируйте pivot.min.css вместо pivot.css.

  • Ознакомительная версия:
Pivot.jsx
import { Pivot } from '@dhx/trial-pivot';
import "@dhx/trial-pivot/dist/pivot.css";

В этом руководстве используется ознакомительная версия Pivot.

Настройка контейнера и монтирование Pivot​

Для отображения Pivot на странице создайте контейнер div, затем инициализируйте Pivot в хуке useEffect с помощью конструктора.

Следующий фрагмент кода определяет минимальный React-компонент Pivot:

Pivot.jsx
import { useEffect, useRef } from "react";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css"; // подключение стилей Pivot

export default function PivotComponent(props) {
let container = useRef(); // реф контейнера для Pivot

useEffect(() => {
// инициализация компонента Pivot
const table = new Pivot(container.current, {});

return () => {
table.destructor(); // уничтожение Pivot при размонтировании
};
}, []);

return <div ref={container} className="widget"></div>;
}

Добавление стилей​

Для корректного отображения Pivot добавьте следующие стили в основной CSS-файл проекта:

index.css
/* стили для начальной страницы */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* стили для контейнера Pivot */
.widget {
height: 100%;
width: 100%;
}

Загрузка данных​

Для передачи данных в Pivot подготовьте набор данных. Создайте src/data.js и экспортируйте данные и метаданные полей:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // другие элементы данных
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // другие поля
];

return { dataset, fields };
};

Откройте src/App.js, импортируйте данные и передайте их в компонент <Pivot/> как пропсы:

App.js
import Pivot from "./Pivot";
import { getData } from "./data";

function App() {
const { fields, dataset } = getData();
return <Pivot fields={fields} dataset={dataset} />;
}

export default App;

Откройте src/Pivot.jsx, деструктурируйте пропсы и примените их к объекту конфигурации Pivot:

Pivot.jsx
import { useEffect, useRef } from "react";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default function PivotComponent({ fields, dataset }) {
let container = useRef();

useEffect(() => {
const table = new Pivot(container.current, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // другие значения
]
},
// другие свойства конфигурации
});

return () => {
table.destructor();
}
}, []);

return <div ref={container} className="widget"></div>;
}

Компонент готов к использованию. При монтировании Pivot отображает переданные данные. Полный список свойств конфигурации см. в документации API Pivot.

Обработка событий​

Действия пользователя в Pivot генерируют события, на которые можно подписаться. Полный список событий см. в обзоре событий.

Следующий фрагмент кода расширяет useEffect обработчиком события open-filter, который записывает в лог идентификатор поля при открытии фильтра пользователем:

Pivot.jsx
// ...
useEffect(() => {
const table = new Pivot(container.current, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // другие значения
]
},
// другие свойства конфигурации
});

table.api.on("open-filter", (ev) => {
console.log("The field id for which the filter is activated:", ev.id);
});

return () => {
table.destructor();
}
}, []);
// ...

Запустите приложение, чтобы увидеть, как Pivot отображает данные на странице.

DHTMLX Pivot, отрендеренный в приложении React с демонстрационными данными

Pivot теперь интегрирован с React. Настройте конфигурацию под требования проекта. Готовый пример см. в react-pivot-demo на GitHub.

Перейти к основному содержимому

Интеграция со Svelte

Подсказка

Предполагается знакомство с основными концепциями и паттернами Svelte. Для повторения см. документацию Svelte.

DHTMLX Pivot интегрируется со Svelte как обычный компонент. Для полного рабочего примера см. демо Svelte Pivot на GitHub.

Создание проекта​

К сведению

Перед началом установите Node.js. Vite — опционально.

Следующая команда запускает инструмент создания проекта Vite и позволяет выбрать шаблон Svelte:

npm create vite@latest

Назовите проект my-svelte-pivot-app.

Установка зависимостей​

Перейдите в директорию нового проекта:

cd my-svelte-pivot-app

Установите зависимости и запустите сервер разработки с помощью менеджера пакетов:

yarn 
yarn start # или: yarn dev
npm install
npm run dev

Приложение должно запуститься на локальном порту (например, http://localhost:3000).

Создание Pivot​

Добавьте пакет Pivot в проект, затем оберните Pivot в компонент Svelte.

Шаг 1. Установка пакета​

Загрузите ознакомительный пакет Pivot и следуйте инструкциям в README. Ознакомительный пакет Pivot действителен в течение 30 дней.

Шаг 2. Создание компонента​

Создайте компонент Svelte, который монтирует Pivot. Добавьте новый файл src/Pivot.svelte.

Импорт исходных файлов​

Откройте src/Pivot.svelte и импортируйте исходные файлы Pivot. Пути импорта зависят от редакции пакета:

  • PRO-версия (установлена из локальной папки):
Pivot.svelte
<script>
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';
</script>

Если пакет поставляется с минифицированными ресурсами, импортируйте pivot.min.css вместо pivot.css.

  • Ознакомительная версия:
Pivot.svelte
<script>
import { Pivot } from '@dhx/trial-pivot';
import '@dhx/trial-pivot/dist/pivot.css';
</script>

В этом руководстве используется ознакомительная версия Pivot.

Настройка контейнера и монтирование Pivot​

Чтобы отобразить Pivot на странице, добавьте контейнер div, затем инициализируйте Pivot в хуке жизненного цикла onMount с помощью конструктора. Уничтожьте Pivot в хуке onDestroy.

Следующий фрагмент кода определяет минимальный компонент Svelte для Pivot:

Pivot.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

let container; // ссылка на контейнер для Pivot
let table;

onMount(() => {
// инициализация компонента Pivot
table = new Pivot(container, {});
});

onDestroy(() => {
table.destructor(); // уничтожение Pivot при размонтировании
});
</script>

<div bind:this={container} class="widget"></div>

Добавление стилей​

Чтобы Pivot отображался корректно, добавьте следующие стили в основной CSS-файл проекта:

main.css
/* стили для начальной страницы */
html,
body,
#app { /* используйте корневой контейнер #app */
height: 100%;
padding: 0;
margin: 0;
}

/* стили для контейнера Pivot */
.widget {
height: 100%;
width: 100%;
}

Загрузка данных​

Чтобы передать данные в Pivot, подготовьте набор данных. Создайте src/data.js и экспортируйте данные и метаданные полей:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // другие элементы данных
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // другие поля
];

return { dataset, fields };
};

Откройте src/App.svelte, импортируйте данные и передайте их новому компоненту <Pivot/> как пропсы:

App.svelte
<script>
import Pivot from "./Pivot.svelte";
import { getData } from "./data.js";

const { fields, dataset } = getData();
</script>

<Pivot fields={fields} dataset={dataset} />

Откройте src/Pivot.svelte, объявите входящие пропсы с помощью export let и примените их к объекту конфигурации Pivot:

Pivot.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export let fields;
export let dataset;

let container;
let table;

onMount(() => {
table = new Pivot(container, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // другие значения
]
},
// другие свойства конфигурации
});
});

onDestroy(() => {
table.destructor();
});
</script>

<div bind:this={container} class="widget"></div>

Компонент готов к использованию. При монтировании Pivot отображает переданные данные. Полный список свойств конфигурации см. в документации API Pivot.

Обработка событий​

Действия пользователя в Pivot вызывают события, на которые можно подписаться. Полный список событий см. в обзоре событий.

Следующий фрагмент кода расширяет onMount обработчиком события open-filter, который записывает в лог идентификатор поля при открытии пользователем фильтра:

Pivot.svelte
<script>
// ...
let table;

onMount(() => {
table = new Pivot(container, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // другие значения
]
},
// другие свойства конфигурации
});

table.api.on("open-filter", (ev) => {
console.log("Идентификатор поля, для которого активирован фильтр:", ev.id);
});
});

onDestroy(() => {
table.destructor();
});
</script>

// ...

Запустите приложение, чтобы увидеть, как Pivot отображает данные на странице.

DHTMLX Pivot, отрендеренный в приложении Svelte с демонстрационными данными

Pivot теперь интегрирован со Svelte. Настройте конфигурацию в соответствии с требованиями проекта. Финальный пример см. на svelte-pivot-demo на GitHub.